/*
   Copyright 2015 Immutables Authors and Contributors

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */
package org.immutables.gson.adapter;

import com.google.common.collect.ListMultimap;
import com.google.common.collect.Multiset;
import com.google.common.collect.SetMultimap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import org.immutables.gson.Gson;
import org.immutables.value.Value;

@Value.Immutable(builder = false)
@Value.Enclosing
@Gson.TypeAdapters
public interface OtherType {

  @Value.Parameter
  ListMultimap<String, Hjk> listMultimap();

  @Value.Parameter
  SetMultimap<Integer, Hjk> setMultimap();

  Map<String, Lui> map();

  @Value.Immutable
  public interface Lui {
    List<Integer> list();

    Map<String, Hjk> map();

    Set<Hjk> set();

    Multiset<Hjk> bag();

    @Value.Parameter
    Object[] arr();
  }

  @Value.Immutable(builder = false)
  public interface Hjk {
    @Value.Parameter
    String[] arr();
  }
}
